#include "hart.h"
#include "Type_defs.h"
#include "register.h"
#include "defs.h"
#include "sbi.h"
#include "memlayout.h"
#include "stdio.h"

struct hart harts[KERNEL_MAX_NUM];    

int32_t myhartid(){
    int32_t id = r_tp();
    return id;
}

struct hart* myhart(){
    int32_t id = myhartid();
    return &harts[id];
}

/*
 * @brief 初始化hart,将hartid写入tp寄存器
 * @param hartid 硬件线程id，最大为 KERNEL_MAX_NUM
*/
inline void init_hartid(uint64_t hartid){
    asm volatile(
        "mv tp, %0" 
        :
        : "r" (hartid % KERNEL_MAX_NUM)
    );
    harts[hartid].interrupt_depth = 0;
}

void wake_other_hart(int64_t boot_hartid){
    uint64_t hart_mask;
    for(int hartid = 0; hartid < KERNEL_MAX_NUM; hartid++){
        if(hartid != boot_hartid){
            sbi_hart_start((uint64_t)hartid, KERNEL_ENTRY, 0);
            hart_mask = 1L << hartid;
            sbi_send_ipi(&hart_mask);
        }
    }
}