//kernel.c
#include "defs.h"
#include "console.h"
#include "stdio.h"
#include "memlayout.h"
#include "trap.h"
#include "memory.h"
#include "vm.h"
#include "register.h"
#include "hart.h"
#include "process.h"

/*
    idle进程完成了。
    明天完成内核进程、上下文切换和用户进程
*/
bool boot_flag = false;

void Kernel_Init(uint64_t hartid)
{
    if(boot_flag == false){

        // 初始化
        init_hartid(hartid);
        init_printlock();
        printf("\n\nThe CannotRunOS is Running!\n");
        printf("\n\nhart ID: %d is ready!\n", hartid);
        init_mem();
        init_kernelvm();
        init_hart_vm();
        printf("1\n");
        init_proc();
        init_hart_idle(hartid);
        init_trap();
        boot_flag = true;
        wake_other_hart(hartid);
        printf("hartid:%d, pid:%d, this is idle\n", hartid, myPCB()->pid);
        init_proc_test();

        // clock_init();       // 这块以后集成一个trap_init()
        //Test
        // panic("Test");
        __sync_synchronize();
    }else{
        //while(!boot_flag){};
        __sync_synchronize();
        init_hartid(hartid);
        printf("\n\nhart ID: %d is ready!\n", hartid);
        init_hart_vm();
        init_hart_idle(hartid);
        init_trap();
        printf("hartid:%d, pid:%d, this is idle\n", hartid, myPCB()->pid);
        clock_init();
        panic("test");
        
    }
    idle();
}