/* linker.ld */
OUTPUT_ARCH(riscv)      /* 指定输出指令集架构 */
ENTRY(start)            /* 指定入口*/

BASE_ADDRESS = 0X80200000;       /* QEMU 指定的内核跳转地址 */

SECTIONS{
    . = BASE_ADDRESS;
    .text :{
        *(.text.start)
        *(.text .text.*)
        . = ALIGN(4096);
        _trampoline = .;
        *(trampsec)
        . = ALIGN(4096);
        ASSERT(. - _trampoline == 4096, "error: trampoline larger than one page\n");
        PROVIDE(text_End = .);
    }

    . = ALIGN(4096);
    .rodata :{
        *(.rodata .rodata.*)
    }

    . = ALIGN(4096);
    .data :{
        *(.data .data.*)
        . = ALIGN(4096);
        *(.stack )
    }

    . = ALIGN(4096);
    .bss :{
        *(.bss .bss.*)
        *(.sbss .sbss.*)
    }

    . = ALIGN(4096);
    PROVIDE(end = .);
}
