#ifndef _MEMORYLAYOUT_
#define _MEMORYLAYOUT_


#define SBI_ENRTY 0X80000000                            // open-sbi的入口

#define MEM_MAX_SIZE 128                                // 128M ram
#define PA_MAX (SBI_ENRTY+ 128*1024*1024)   
#define KERNEL_ENTRY 0X80200000L                         // 内核入口
#define KERNEL_STACK_SIZE (1<<12)                       // 每个hart分配4kb的内核栈
#define KERNEL_STACK_SIZE_SHIFT 12                      // 1<<12 同上    
#define PYHSTOP (SBI_ENRTY+MEM_MAX_SIZE*1024*1024)      // dram上限

#define PGSIZE   (1<<12)                             //一页的大小 4K
#define PGSIZE_SHIFT 12          

#define TRAMPOLINE (MAXVA - PGSIZE)                     // 蹦床 用于用户态进程陷入内核态
#define TRAPFRAME (TRAMPOLINE - PGSIZE)
// map kernel stacks beneath the trampoline,
// each surrounded by invalid guard pages.
#define KSTACK(p) (TRAMPOLINE - ((p)+1)* 2*PGSIZE)

// 使用了 xv6 kernel/memlayout.h
// qemu -machine virt
#define UART0 0x10000000L           
#define UART0_IRQ 10

// virtio mmio interface
#define VIRTIO0 0x10001000
#define VIRTIO0_IRQ 1


#endif