//可变长参数  https://blog.csdn.net/lidan113lidan/article/details/123962416

#include "stdio.h"
#include "console.h"
#include "string.h"
#include "spinlock.h"
#include "hart.h"

struct spinlock print_lock;


inline void init_printlock(){
    init_lock(&print_lock, "print_lock");
}

// 输出
/*
 * @brief 输出一个字符到控制台
 * @param   char ch
 * @retval  return -1 if failed
*/
int32_t putchar(char ch){
    int32_t retval;
    retval = console_putchar((int32_t)ch);
    if(retval !=0 ) {
        //mark 错误处理 error code
    }
    return 1;
}

/*
 * @brief   输出字符串到控制台
 * @param   const char *ch 字符指针
 * @retval  count of char 
*/
int32_t putstr(const char *ch){
    int32_t i;
    for(i = 0 ; ch[i] != '\0'; i++){
        putchar(ch[i]);
    }
    return i;
}

/*
 * m_pow_n() 和 Print() 有略微修改
 * —————————————————————————————————————————————————————————————————————————————————
 * 版权声明：本文为CSDN博主「老子姓李！」的原创文章，遵循CC 4.0 BY-SA版权协议，转载请附上原文出处链接及本声明。
 * 原文链接：https://blog.csdn.net/qq_44078824/article/details/118440458
 * —————————————————————————————————————————————————————————————————————————————————
*/
// 计算m^n
unsigned long m_pow_n(unsigned long m, unsigned long n)
{
    unsigned long i = 0, ret = 1;
    if (n < 0) return 0;
    for (i = 0; i < n; i++)
    {
        ret *= m;
    }
    return ret;
}

// 返回值为打印字符的个数
// 支持%d，%o, %x，%s，%c，%f（只打印6位数字）
int print(const char* fmt, va_list ap)
{
    if (fmt == NULL) return -1;

	unsigned int ret_num = 0;       // 返回打印字符的个数
    char* pStr = (char*)fmt;        // 指向str
    int ArgIntVal = 0;              // 接收整型
    unsigned long ArgHexVal = 0;    // 接十六进制
    char* ArgStrVal = NULL;         // 接收字符型
    double ArgFloVal = 0.0;         // 接受浮点型
    unsigned long val_seg = 0;      // 数据切分
    unsigned long val_temp = 0;     // 临时保存数据
    int cnt = 0;                    // 数据长度计数
    //int i = 0;
    
    // va_list ap;                     // 定义va_list类型指针，用于存储参数的地址
    // va_start(ap, fmt); // 初始化pArgs
    while (*pStr != '\0')
    {
        switch (*pStr)
        {
        case ' ':
            putchar(*pStr); ret_num++; break;
        case '\t':
            putchar(*pStr); ret_num += 4; break;
        case '\r':
            putchar(*pStr); ret_num++; break;
        case '\n':
            putchar(*pStr); ret_num++; break;
        case '%':
            pStr++;
            // % 格式解析
            switch (*pStr)
            {
            case '%':
                putchar('%');// %%，输出%
                ret_num++;
                pStr++;
				continue;
            case 'c':
                ArgIntVal = va_arg(ap, int);// %c，输出char
                putchar((char)ArgIntVal);
                ret_num++;
                pStr++;
				continue;
            case 'd':
                // 接收整型
                ArgIntVal = va_arg(ap, int);
                if (ArgIntVal < 0)// 如果为负数打印，负号
                {
                    ArgIntVal = -ArgIntVal;// 取相反数

                    putchar('-');
                    ret_num++;
                }
                val_seg = ArgIntVal;// 赋值给 val_seg处理数据
                // 计算ArgIntVal长度
                if (ArgIntVal)
                {
                    while (val_seg) {
                        cnt++;
                        val_seg /= 10;
                    }
                }
                else cnt = 1;// 数字0的长度为1

                ret_num += cnt;// 字符个数加上整数的长度

                // 将整数转为单个字符打印
                while (cnt)
                {
                    val_seg = ArgIntVal / m_pow_n(10, cnt - 1);
                    ArgIntVal %= m_pow_n(10, cnt - 1);
                    putchar((char)val_seg + '0');
                    cnt--;
                }
                pStr++;
                continue;
            case 'o':
                // 接收整型
                ArgIntVal = va_arg(ap, int);
                if (ArgIntVal < 0)// 如果为负数打印，负号
                {
                    ArgIntVal = -ArgIntVal;// 取相反数

                    putchar('-');
                    ret_num++;
                }
                val_seg = ArgIntVal;// 赋值给 val_seg处理数据
                // 计算ArgIntVal长度
                if (ArgIntVal)
                {
                    while (val_seg) {
                        cnt++;
                        val_seg /= 8;
                    }
                }
                else cnt = 1;// 数字0的长度为1

                ret_num += cnt;// 字符个数加上整数的长度

                // 将整数转为单个字符打印
                while (cnt)
                {
                    val_seg = ArgIntVal / m_pow_n(8, cnt - 1);
                    ArgIntVal %= m_pow_n(8, cnt - 1);
                    putchar((char)val_seg + '0');
                    cnt--;
                }
                pStr++;
				continue;
            case 'x':
                // 接收16进制
                ArgHexVal = va_arg(ap, unsigned long);
                val_seg = ArgHexVal;
                // 计算ArgIntVal长度
                if (ArgHexVal)
                {
                    while (val_seg) {
                        cnt++;
                        val_seg /= 16;
                    }
                }
                else cnt = 1;// 数字0的长度为1

                ret_num += cnt;// 字符个数加上整数的长度
                // 将整数转为单个字符打印
                while (cnt)
                {
                    val_seg = ArgHexVal / m_pow_n(16, cnt - 1);
                    ArgHexVal %= m_pow_n(16, cnt - 1);
                    if (val_seg <= 9)
                        putchar((char)val_seg + '0');
                    else
                    {
						//putchar((char)val_seg - 10 + 'a'); //小写字母
                        putchar((char)val_seg - 10 + 'A');
                    }
                    cnt--;
                }
                pStr++;
				continue;
            case 'b':
                // 接收整型
                ArgIntVal = va_arg(ap, int);
                val_seg = ArgIntVal;
                // 计算ArgIntVal长度
                if (ArgIntVal)
                {
                    while (val_seg) {
                        cnt++;
                        val_seg /= 2;
                    }
                }
                else cnt = 1;// 数字0的长度为1

                ret_num += cnt;// 字符个数加上整数的长度
                // 将整数转为单个字符打印
                while (cnt)
                {
                    val_seg = ArgIntVal / m_pow_n(2, cnt - 1);
                    ArgIntVal %= m_pow_n(2, cnt - 1);
                    putchar((char)val_seg + '0');
                    cnt--;
                }
                pStr++;
				continue;
            case 's':
                // 接收字符
                ArgStrVal = va_arg(ap, char*);
                ret_num += (unsigned int)strlen(ArgStrVal);
                while (*ArgStrVal)
                {
                    putchar(*ArgStrVal);
                    ArgStrVal++;
                }

                pStr++;
				continue;

            case 'f':
                // 接收浮点型 保留6为小数，不采取四舍五入
                ArgFloVal = va_arg(ap, double);
                val_seg = (unsigned long)ArgFloVal;// 取整数部分
                val_temp = val_seg;      // 临时保存整数部分数据
                ArgFloVal = ArgFloVal - val_seg;// 得出余下的小数部分
                // 计算整数部分长度
                if (val_seg)
                {
                    while (val_seg) {
                        cnt++;
                        val_seg /= 10;
                    }
                }
                else cnt = 1;// 数字0的长度为1
                ret_num += cnt;// 字符个数加上整数的长度
                // 将整数转为单个字符打印
                while (cnt)
                {
                    val_seg = val_temp / m_pow_n(10, cnt - 1);
                    val_temp %= m_pow_n(10, cnt - 1);
                    putchar((char)val_seg + '0');
                    cnt--;
                }
                // 打印小数点
                putchar('.');
                ret_num++;
                // 开始输出小数部分
                ArgFloVal *= 1000000;
                // printf("\r\n %f\r\n", ArgFloVal);
                cnt = 6;
                val_temp = (int)ArgFloVal;// 取整数部分
                while (cnt)
                {
                    val_seg = val_temp / m_pow_n(10, cnt - 1);
                    val_temp %= m_pow_n(10, cnt - 1);
                    putchar((char)val_seg + '0');
                    cnt--;
                }
                ret_num += 6;
                pStr++;
				continue;
            default:// % 匹配错误，暂输出空格
				putchar(' '); ret_num++;
				continue;
            }


        default:
            putchar(*pStr); ret_num++;
            break;
        }
        pStr++;
    }
    va_end(ap);// 结束取参数

    return ret_num;
}

/*
 * @brief 
 * @detals 
 * @param
 * @retval 
*/
void printf(const char *fmt, ...){
    acquire_lock(&print_lock);
    va_list ap = NULL;
    va_start(ap, fmt);
    print(fmt, ap);
    va_end(ap);
    release_lock(&print_lock);
}


// 输入
/*
 * @brief 从控制台接收一个字符，不跳过空格 
 * @param   void
 * @retval 一个非0的字符 
*/
char getchar(void){
    int32_t ch;
    while(( ch = console_getchar() ) != 0){
        // nothing
    }
    return (char)ch;
}

/*
 * @brief   从控制台读入字符串，遇到空格或换行停止
 * @param   接收字符串的地址
 * @retval  count of char 
*/
int32_t getstr(char *buff){
    int32_t i=0;
    do{
        buff[i] = getchar();
    }while(buff[i++] != ' ' && buff[i] != '\n');
    buff[i] = '\0';
    return i;
}

// 错误
/*
 * @brief 报错，然后死循环
 * @param error message
*/
void panic(char *message){
    printf("hartid:%d panic: %s\n",  myhartid(), message);
    while(1){
        //死循环
    }
}
