#ifndef _TRAP_
#define _TRAP_
#include "riscv.h"

//中断和异常处理
// riscv-privileged-20190608-1.pdf P62  
// exception code of scause register,for interrupt 
#define U_SOFTWARE_INTERRUPT    0
#define S_SOFTWARE_INTERRUPT    1
#define U_TIMER_INTERRUPT       4
#define S_TIMER_INTERRUPT       5
#define U_EX_INTERRUPT          8
#define S_EX_INTERRUPT          9

// exception code of scause register,for exception

#define Instruction_Address_Misaligned 0
#define Instruction_access_fault 1
#define Illegal_instruction 2
#define Breakpoint 3
#define Load_address_misaligned 4
#define Load_access_fault 5
#define Store_or_AMO_address_misaligned 6
#define Store_or_AMO_access_fault 7
#define Environment_call_from_Umode 8
#define Environment_call_from_Smode 9
#define Instruction_page_fault 12
#define Load_page_fault 13
#define Store_or_AMO_page_fault 15



void kerneltrap(void);
void usertrap(void);

void interrupt_handdle();
void exception_handler();

void init_trap();

//时钟中断
#define TIMEBASE 100000    // 1^(7)为1s
//static inline uint64_t get_time(void);
void clock_init(void);
void clock_set_next_interrupt(void);

#endif