#ifndef _VM_
#define _VM_

#include "Type_defs.h"

typedef uint64_t pte_t;
typedef pte_t *pgtable_t;            // 含有512pte

void init_kernelvm();
int map_pages(pgtable_t pagetable, uint64_t va, 
            uint64_t size, uint64_t pa, int perm);
pte_t* get_last_pgtable(pgtable_t pagetable, uint64_t va, int alloc);

static inline void sfence_vma(){
    asm volatile("sfence.vma zero, zero");
}
void init_hart_vm();

pgtable_t alloc_user_pgtable();
pgtable_t alloc_kernel_pgtable();
bool uvmcopy(pgtable_t old, pgtable_t new, uint64_t sz);
bool free_map(pgtable_t pagetable, uint64_t va, uint64_t npages, int32_t do_free);
// pgtable_t alloc_pgtable();
#endif